<script>
    export let plot_element;
    export let data;
    export let xScale;
    export let yScale;
    import * as d3 from "d3";

    // Default settings
    $: vertical_placement =
        "vertical_placement" in plot_element.plot_options
            ? plot_element.plot_options.vertical_placement
            : "parameter";
    $: constant_y =
        "constant_y" in plot_element.plot_options
            ? plot_element.plot_options.constant_y
            : 0;
    $: prevent_overlap_x =
        "prevent_overlap_x" in plot_element.plot_options
            ? plot_element.plot_options.prevent_overlap_x
            : 0;
    $: sort_by_y =
        "sort_by_y" in plot_element.plot_options
            ? plot_element.plot_options.sort_by_y
            : "descending";
    $: side =
        "side" in plot_element.plot_options
            ? plot_element.plot_options.side
            : "inside";
    $: tick_length =
        "tick_length" in plot_element.plot_options
            ? plot_element.plot_options.tick_length
            : 10;
    $: tick_length_mode =
        "tick_length_mode" in plot_element.plot_options
            ? plot_element.plot_options.tick_length_mode
            : "absolute";

    const generate_ticks = function (data, plot_element, xScale, yScale) {
        let sorted_data;
        if (sort_by_y == "ascending") {
            sorted_data = data.datalist.sort(
                (a, b) =>
                    b[plot_element.data.parameter] -
                    a[plot_element.data.parameter],
            );
        } else if (sort_by_y == "descending") {
            sorted_data = data.datalist.sort(
                (a, b) =>
                    b[plot_element.data.parameter] -
                    a[plot_element.data.parameter],
            );
        } else {
            sorted_data = data.datalist;
        }

        let ticks = [];

        let mode_factor =
            tick_length_mode == "relative"
                ? (yScale.range()[0] - yScale.range()[1]) / 100
                : 1;
        for (let d of sorted_data) {
            let x = xScale(new Date(d.time));
            let y0;
            let y1;
            let sign = 1;
            if (
                (vertical_placement == "bottom" && side == "inside") ||
                (vertical_placement == "top" && side == "outside")
            ) {
                sign = -1;
            }

            if (vertical_placement == "parameter") {
                y0 = yScale(d[plot_element.data.parameter]);
                y1 = y0 + sign * tick_length * mode_factor;
            } else if (vertical_placement == "constant") {
                y0 = yScale(plot_element.plot_options.constant_y);
                y1 = y0 + sign * tick_length * mode_factor;
            } else if (vertical_placement == "top") {
                y0 = yScale.range()[1];
                y1 = y0 + sign * tick_length * mode_factor;
            } else if (vertical_placement == "bottom") {
                y0 = yScale.range()[0];
                y1 = y0 + sign * tick_length * mode_factor;
            } else if (vertical_placement == "grid") {
                y0 = yScale.range()[0];
                y1 = yScale.range()[1];
            }

            let plot_tick = true;
            for (let t of ticks) {
                if (Math.abs(x - t.x) < prevent_overlap_x) {
                    plot_tick = false;
                }
            }
            if (plot_tick) {
                ticks.push({ x: x, y0: y0, y1: y1 });
            }
        }
        return ticks;
    };

    $: ticks = generate_ticks(data, plot_element, xScale, yScale);
</script>

{#each ticks as t}
    <line
        x1={t.x}
        x2={t.x}
        y1={t.y0}
        y2={t.y1}
        class="stroke-black dark:stroke-white"
        stroke-width="{plot_element.plot_options.stroke_width}px" />
{/each}

<style>
</style>
